package monnethic.mobile.homepage;

import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.example.monnthic.monnethicmobile.R;

import org.json.JSONObject;

import monnethic.mobile.restApi.Config;
import monnethic.mobile.restApi.HttpCallHandler;
import monnethic.mobile.user.UserAccountActivity;

public class LoginActivity extends AppCompatActivity {
    private EditText email;
    private EditText password;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        email = findViewById(R.id.editTextEmail);
        password = findViewById(R.id.editTextPassword);
        Button buttonCancel = findViewById(R.id.buttonCancel);
        Button buttonOk = findViewById(R.id.buttonOk);

        buttonCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
        buttonOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                validateInput();
            }
        });
    }

    public void onClickForgetPassword(View v){
        Toast.makeText(this, "Forget password", Toast.LENGTH_SHORT).show();
    }
    public void onClickForgetEmail(View v){
        Toast.makeText(this, "Forget email", Toast.LENGTH_SHORT).show();
    }
    private void validateInput(){
        if(InputController.isEmptyEdit(email)){
            Toast.makeText(this, "You did not enter your email", Toast.LENGTH_SHORT).show();
        } else if(!InputController.validEmail(email.getText().toString())){
            Toast.makeText(this, "Your email is invalid", Toast.LENGTH_SHORT).show();
        } else if(InputController.isEmptyEdit(password)) {
            Toast.makeText(this, "You did not enter your password", Toast.LENGTH_SHORT).show();
        } else {
            if(InputController.checkUser(email.getText().toString(),password.getText().toString())){
                String[] params = {email.getText().toString(),password.getText().toString()};
                new UserLoggerTask(this).execute(params);
            }else{
                Toast.makeText(this, "Wrong authentication", Toast.LENGTH_SHORT).show();
            }
        }
    }

    //AsyncTask for login
    private class UserLoggerTask extends AsyncTask<String,String,JSONObject> {
        Context mContext;
        private UserLoggerTask(final Context context){
            mContext = context;
        }

        @Override
        protected void onPostExecute(JSONObject result) {
            try{
                if(result!=null){
                    if(result.getInt("status") == 200){
                        Intent accountIntent = new Intent(LoginActivity.this, UserAccountActivity.class);
                        accountIntent.putExtra("userHash", result.getString("userHash"));
                        LoginActivity.this.startActivity(accountIntent);
                        finish();
                    }else{
                        Toast.makeText(mContext, result.getString("response"), Toast.LENGTH_SHORT).show();
                    }
                }else{
                    Toast.makeText(mContext, "AN ERROR OCCURED", Toast.LENGTH_SHORT).show();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        @Override
        protected JSONObject doInBackground(String... params) {
            try{
                String url = Config.USER_LOGIN;
                String[] paramsList = {params[0],params[1]};
                HttpCallHandler httpCallHandler = new HttpCallHandler();
                return new JSONObject(httpCallHandler.executeLoginHttp(url,paramsList));
            }catch (Exception e){
                e.printStackTrace();
                return null;
            }

        }
    }

}
