package monnethic.mobile.qrcode;

import android.content.Intent;
import android.graphics.Bitmap;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.example.monnthic.monnethicmobile.R;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.journeyapps.barcodescanner.BarcodeEncoder;

public class QrCodeActivity extends AppCompatActivity {
    ImageView qrCode;
    Button closeButton;
    TextView adresseView;
    TextView amountView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_qr_code);
        qrCode=findViewById(R.id.qrCodeViewer);
        closeButton=findViewById(R.id.buttonClose);
        adresseView=findViewById(R.id.textViewAdresseDisplay);
        amountView=findViewById(R.id.textViewAmountDisplay);

        Intent intent = getIntent();
        String adresse = intent.getStringExtra("adresse");
        String value = intent.getStringExtra("value");
        try{
            generateQrCode(adresse,value);
        }catch(Exception e){
            e.getMessage();
        }
        closeButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
    }

    private void generateQrCode(String adresse, String value) throws WriterException {
        BitMatrix bitMatrix;
        String valueToEncode = adresse+";"+value;
        try{
            bitMatrix = new MultiFormatWriter().encode(valueToEncode, BarcodeFormat.QR_CODE,350,350);
            BarcodeEncoder barcodeEncoder = new BarcodeEncoder();
            Bitmap bitmap = barcodeEncoder.createBitmap(bitMatrix);
            qrCode.setImageBitmap(bitmap);
            adresseView.setText(adresse);
            amountView.setText(value);
        }catch (Exception e){
            e.getMessage();
        }
    }
}
