package monnethic.mobile.user;

import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.example.monnthic.monnethicmobile.R;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

import monnethic.mobile.database.User;
import monnethic.mobile.restApi.Config;
import monnethic.mobile.restApi.HttpCallHandler;
import monnethic.mobile.transaction.MakePayementActivity;
import monnethic.mobile.transaction.ReceivePayementActivity;

public class UserAccountActivity extends AppCompatActivity {
    private TextView balance;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_user_account);
        balance = findViewById(R.id.balanceView);
        TextView userHashView = findViewById(R.id.userHash);
        Button buttonPayement = findViewById(R.id.buttonPayement);
        Button buttonReceive = findViewById(R.id.buttonReceive);
        Button buttonSettings = findViewById(R.id.buttonSettings);
        Button buttonRefresh = findViewById(R.id.buttonRefreshBalance);
        Intent intent = getIntent();
        String userHash = intent.getStringExtra("userHash");
        userHashView.setText(userHash);

        buttonPayement.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                sendPayement();
            }
        });
        buttonReceive.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                receivePayement();
            }
        });
        buttonSettings.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                settings();
            }
        });
        buttonRefresh.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                refreshBalance("b");
            }
        });

        String[] params = {userHash};
        new GetUserBalanceTask().execute(params);
    }

    public void sendPayement(){
        Intent payementIntent = new Intent(UserAccountActivity.this, MakePayementActivity.class);
        UserAccountActivity.this.startActivity(payementIntent);
    }
    public void receivePayement(){
        Intent receivePayementIntent = new Intent(UserAccountActivity.this, ReceivePayementActivity.class);
        UserAccountActivity.this.startActivity(receivePayementIntent);
    }
    public void settings(){
        Toast.makeText(this, "Coming soon", Toast.LENGTH_SHORT).show();
    }

    public void refreshBalance(String userHash){
        String url = Config.QUERY_BALANCE+userHash;
        new GetUserBalanceTask().execute(url);
    }

    public void setBalance(String value){
        balance.setText(value);
    }


    public class GetUserBalanceTask extends AsyncTask<String,String,String>
    {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected void onPostExecute(String s) {
            if(s!=null){
                balance.setText(s);
            }else{
                balance.setText("0");
            }

        }

        @Override
        protected String doInBackground(String... params) {
            try{
                String url = Config.QUERY_BALANCE+params[0];
                HttpCallHandler httpCallHandler = new HttpCallHandler();
                JSONObject json = new JSONObject(httpCallHandler.executeGetBalance(url));
                if(json.get("userBalance")!=null){
                    Double balance = json.getDouble("userBalance");
                    return balance.toString();
                }else{
                    return null;
                }

            } catch (Exception e){
                e.printStackTrace();
                return null;
            }
        }
    }
}
